/***********************************************************************
 * File: days-test.c
 * 	(Extracted from
 *	   "$Id: days-test.c,v 1.1 2007/10/29 06:55:00 Administrator Exp Administrator $")
 *
 * Abstracts:
 *  This C source implements the test program for is_valid_date() and
 * date_in_English() API-s.
 *
 * Copyright (C) 2005-2007 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

#include "days.h"

int main(int ac, char **av)
{
	long long	count;
	size_t		i, j;
	char		*mmdd[] = {
			  "0000", "0100", "0101", "0131", "0132"
			, "0200", "0201", "0228", "0229", "0230"
			, "0300", "0301", "0331", "0332"
			, "0400", "0401", "0430", "0431"
			, "0500", "0501", "0531", "0532"
			, "0600", "0601", "0630", "0631"
			, "0700", "0701", "0731", "0732"
			, "0800", "0801", "0831", "0832"
			, "0900", "0901", "0930", "0931"
			, "1000", "1001", "1031", "1032"
			, "1100", "1101", "1130", "1131"
			, "1200", "1201", "1231", "1232"
			}
			, *year[] = {
			  "0000", "0001", "", "0", "1", "2", "3", "4"
			, "5", "6", "7", "8", "9"
			, "10", "11", "12", "13", "14"
			, "15", "16", "17", "18", "19"
			, "110", "111", "112", "113", "114"
			, "115", "116", "117", "118", "119"
			, "2000", "2001", "2002", "2003", "2004"
			, "2005", "2006", "2007", "2008", "2009"
			, "4294967295", "4294967296"
			}
			, date[15], str[26], *datep
			, org_date[sizeof(date)];
	Day_of_week_e	day_of_week;
	char		**sv_av, *dow_str;
	int		sv_ac;

	sv_ac = ac; sv_av = av; ac = sv_ac; av = sv_av;

	datep	= strcpy(date, "00001341");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00010101");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00010201");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00010301");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00011231");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00040101");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00040201");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00040301");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "00041231");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "10000101");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "10000201");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "10000301");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "10001231");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "20000101");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "20000201");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "20000301");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);
	datep	= strcpy(date, "20001231");
	printf("get_day_of_year(\"%s\", %ld) returns %d.\n"
		,		datep, (long)strlen(datep)
		,		get_day_of_year(datep, strlen(datep))
		); (void)fflush(stdout);

	printf("-----------------------------------\n")
	; (void)fflush(stdout);
	strcpy(date, "00010101");
	str[0]	= '\0';
	printf("days_count(\"%s\", %ld) "
		"returns %lld.\n"
		, date, (long)strlen(date)
		, days_count(date, strlen(date))
		); (void)fflush(stdout);
	strcat(strcat(str, year[(sizeof(year) / sizeof(year[0])) - 2])
		, "1231"
		);
	printf("days_count(\"%s\", %ld) "
		"returns %lld.\n"
		, str, (long)strlen(str)
		, days_count(str, strlen(str))
		); (void)fflush(stdout);
	count	= diff_dates(date, strlen(date), str, strlen(str));
	if (count == LLONG_MIN) {
		printf("!!ERROR!! ");
	}
	printf("diff_dates(\"%s\", %ld,"
		" \"%s\", %ld) "
		" returns %lld.\n"
		,	date, (long)strlen(date)
		, str, (long)strlen(str)
		,		count
		); (void)fflush(stdout);
	count	= diff_dates(str, strlen(str), date, strlen(date));
	if (count == LLONG_MIN) {
		printf("!!ERROR!! ");
	}
	printf("diff_dates(\"%s\", %ld,"
		" \"%s\", %ld) "
		" returns %lld.\n"
		,	str, (long)strlen(str)
		, date, (long)strlen(date)
		,		count
		); (void)fflush(stdout);
	printf("\n"); (void)fflush(stdout);

	for (i = 0; i < sizeof(year) / sizeof(year[0]); ++i) {
		for (j = 0; j < sizeof(mmdd) / sizeof(mmdd[0]); ++j) {
			unsigned long	year_, year__ = 0;
			int		month_, month__ = 0
					, day_, day__ = 0
					;
			Duration_unit_e	units[] = {
						  Duration_unit_Years
						, Duration_unit_Months
						, Duration_unit_Weeks
						};
			Duration_t	duration;
			long long	deltas[] = { -1LL, 0LL, 1LL };
			DAYS_FMT	fmt;
			size_t		unitix, deltaix;
			int		result;
			char		*days;

			date[0]	= '\0';
			strcat(strcat(date, year[i]), mmdd[j]);
			printf("date is \"%s\".\n", date
			); (void)fflush(stdout);

			result	= is_valid_date(date, strlen(date));
			if (result != DAYS_TRUE) {
				printf("!!ERROR!! ");
			}
			printf("is_valid_date(\"%s\", %lu) "
				"returns %d.\n"
				,	date
				,	(unsigned long)strlen(date)
				, result
				); (void)fflush(stdout);

			year_	= (unsigned long)(month_ = day_ = 0);
			result	= get_ymd(date
					, strlen(date)
					, &year_
					, &month_
					, &day_
					);
			if (result != 0) {
				printf("!!ERROR!! ");
			}
			printf("get_ymd(date=[%s], sz=%lu, "
				"&year_@%p, &month_@%p, &day_@%p) "
				"returns %d"
				, date, (unsigned long)strlen(date)
				, (void *)&year_, (void *)&month_
				,			(void *)&day_
				, result
				);
			if (result == 0) {
				printf(" (outputs year_=%lu, "
					"month_=%d, day_=%d)"
					, year_
					, month_, day_
					);
			}
			printf(".\n"); (void)fflush(stdout);

			fmt	= DAYS_FMT_EUROPEAN;
			days	= date_in_English(date
						, strlen(date)
						, fmt
						, str
						, sizeof(str)
						);
			if (days == NULL) {
				printf("!!ERROR!! ");
			}
			printf("date_in_English(\"%s\", %ld, %d, %p"
				", %ld) returns %p."
				, date, (long)strlen(date), fmt, str
				, (long)sizeof(str), days
				);
			if (days != NULL) {
				printf(" [str is \"%s\"]", str);
			}
			printf("\n"); (void)fflush(stdout);

			fmt	= DAYS_FMT_AMERICAN;
			days	= date_in_English(date
						, strlen(date)
						, fmt
						, str
						, sizeof(str)
						);
			if (days == NULL) {
				printf("!!ERROR!! ");
			}
			printf("date_in_English(\"%s\", %ld, %d, %p"
				", %ld) returns %p."
				, date, (long)strlen(date), fmt, str
				, (long)sizeof(str), days
				);
			if (days != NULL) {
				printf(" [str is \"%s\"]", str);
			}
			printf("\n"); (void)fflush(stdout);

			count = days_count(date, strlen(date));
			if (count == LLONG_MIN) {
				printf("!!ERROR!! ");
			}
			printf("days_count(\"%s\", %ld) returns %lld.\n"
				,	date, (long)strlen(date), count
				); (void)fflush(stdout);

			result	= days_count_to_ymd(count
						, &year__
						, &month__
						, &day__
						);
			if ((result != DAYS_ILLEGAL_ARGS)
			&& (year_ != year__
				|| month_ != month__
				|| day_ != day__)
			) {
				printf("!!!FATAL!!! results of "
					"days_count_to_ymd(count=%lld, "
					"year__@%p, month__@%p, "
					"day__@%p) is differ to "
					"(year_=%lu, month_=%d, "
					"day_=%d)!\n"
					,			count
					, (void *)&year__
					, (void *)&month__
					, (void *)&day__
					, year_, month_, day_
					); (void)fflush(stdout)
					;
				exit(EXIT_FAILURE); /* Failed! */
			}

			day_of_week	= day_of_week(count);
			dow_str	= day_of_week_str(count);
			printf("day_of_week(%lld) returns %d.\n"
				,	count,	(int)day_of_week
				); (void)fflush(stdout);
			printf("day_of_week_str(%lld) returns "
							"@%p[%s].\n"
				,	count
				,	dow_str
				,	((dow_str != NULL)?
							dow_str: "(n/a)"
					)
				); (void)fflush(stdout);
			if (get_day_of_week(date, strlen(date))
							!= dow_str) {
				printf("!!!FATAL!!! return of "
					"get_day_of_week(date=[%s], "
					"sz=%lu) is differ to "
					"dow_str@%p!\n"
					,		date
					, (unsigned long)strlen(date)
					, dow_str
					); (void)fflush(stdout)
					;
				exit(EXIT_FAILURE); /* Failed! */
			}

			str[0]	= '\0';
			strcat(strcat(str, year[i])
				, mmdd[(j == sizeof(mmdd)
						/ sizeof(mmdd[0]) - 1)?
							0: j + 1
					]
				);
			printf("str is \"%s\".\n", str
			); (void)fflush(stdout);
			count = diff_dates(str
					, strlen(str)
					, date
					, strlen(date)
					);
			if (count == LLONG_MIN) {
				printf("!!ERROR!! ");
			}
			printf("diff_dates(\"%s\", %ld,"
				" \"%s\", %ld) "
				" returns %lld.\n"
				,	str, (long)strlen(str)
				, date, (long)strlen(date)
				,		count
				); (void)fflush(stdout);

			for (unitix = 0
			; unitix < (sizeof(units) / sizeof(units[0]))
			; ++unitix) {
			for (deltaix = 0
			; deltaix < (sizeof(deltas) / sizeof(deltas[0]))
			; ++deltaix) {
				Duration_t	*res_calc_duration;

				errno	= 0;
				res_calc_duration = calc_duration(date
					, units[unitix]
					, deltas[deltaix]
					, memset(&duration
						, (int)'\0'
						, sizeof(duration)
						)
					);
				if (res_calc_duration == NULL) {
					printf("!!!ERROR!!! ")
					; (void)fflush(stdout)
					;
				}
				printf("calc_duration(date=[%s], "
					"unit=%d, delta=%lld, "
					"&duration@%p) returns @%p"
					,		date
					, units[unitix], deltas[deltaix]
					, (void *)&duration
					, (void *)res_calc_duration
					); (void)fflush(stdout)
					;
				if (res_calc_duration != NULL) {
					printf(" (outputs duration={"
						"begin_of=%lld, "
						"end_of=%lld, "
						"days=%lld })"
						, res_calc_duration
							->begin_of
						, res_calc_duration
							->end_of
						, res_calc_duration
							->days
						); (void)fflush(stdout)
						;
				}
				else {
					printf(" (errno=%d [%s])"
						, errno
						, strerror(errno)
						); (void)fflush(stdout)
						;
				}
				printf(".\n"); (void)fflush(stdout);

				if (((count = days_count(date
							, strlen(date)
							)) != LLONG_MIN)
				&& get_duration(count
						, units[unitix]
						, deltas[deltaix]
						, &duration
						) != res_calc_duration)
				{
					printf("!!!FATAL!!! return of "
						"get_duration("
						"day_count=%lld, "
						"unit=%d, "
						"delta=%lld, "
						"&duration@%p) "
						"is differ to "
						"res_calc_duration=%p"
						"!\n"
						, count
						, units[unitix]
						, deltas[deltaix]
						, (void *)&duration
						, (void *)
						       res_calc_duration
						); (void)fflush(stdout)
						;
					exit(EXIT_FAILURE);
							/* Failed! */
				}
			}}
		}
		printf("\n"); (void)fflush(stdout);
	}

	strcpy(date, "00010101");
	str[0]	= '\0';
	printf("days_count(\"%s\", %ld) "
		"returns %lld.\n"
		, date, (long)strlen(date)
		, days_count(date, strlen(date))
		); (void)fflush(stdout);
	strcat(strcat(str, year[(sizeof(year) / sizeof(year[0])) - 2])
		, "1231"
		);
	printf("days_count(\"%s\", %ld) "
		"returns %lld.\n"
		, str, (long)strlen(str)
		, days_count(str, strlen(str))
		); (void)fflush(stdout);
	printf("is_valid_date(\"%s\", %lu) returns %d.\n"
		,	str, (unsigned long)strlen(str)
		, is_valid_date(str, strlen(str))
		); (void)fflush(stdout);
	count	= diff_dates(date, strlen(date), str, strlen(str));
	if (count == LLONG_MIN) {
		printf("!!ERROR!! ");
	}
	printf("diff_dates(\"%s\", %ld,"
		" \"%s\", %ld) "
		" returns %lld.\n"
		,	date, (long)strlen(date)
		, str, (long)strlen(str)
		,		count
		); (void)fflush(stdout);
	count	= diff_dates(str, strlen(str), date, strlen(date));
	if (count == LLONG_MIN) {
		printf("!!ERROR!! ");
	}
	printf("diff_dates(\"%s\", %ld,"
		" \"%s\", %ld) "
		" returns %lld.\n"
		,	str, (long)strlen(str)
		, date, (long)strlen(date)
		,		count
		); (void)fflush(stdout);

	printf("----------------------------------\n")
	; (void)fflush(stdout);
	/* error cases... */
	count	= 0; /* invalid arguments */
	datep	= days_count_to_date_str(count
					, NULL
					, 8
					);
	printf("days_count_to_date_str(day_count (%lld), "
		"date@%p, sz (%d)) returns @%p [%s](len=%lu).\n"
		,				count
		, NULL, 8, datep
		, ((datep == NULL)? "(n/a)": datep)
		, (unsigned long)((datep == NULL)?
					(size_t)INT_MIN: strlen(datep)
					)
		); (void)fflush(stdout);

	count	= 1;
	datep	= days_count_to_date_str(count
					, NULL /* invalid arguments */
					, 8
					);
	printf("days_count_to_date_str(day_count (%lld), "
		"date@%p, sz (%d)) returns @%p [%s](len=%lu).\n"
		,				count
		, NULL, 8, datep
		, ((datep == NULL)? "(n/a)": datep)
		, (unsigned long)((datep == NULL)?
					(size_t)INT_MIN: strlen(datep)
					)
		); (void)fflush(stdout);

	count	= 1;
	datep	= days_count_to_date_str(count
					, date
					, 8 /* invalid arguments */
					);
	printf("days_count_to_date_str(day_count (%lld), "
		"date@%p, sz (%d)) returns @%p [%s](len=%lu).\n"
		,				count
		, date, 8, datep
		, ((datep == NULL)? "(n/a)": datep)
		, (unsigned long)((datep == NULL)?
					(size_t)INT_MIN: strlen(datep)
					)
		); (void)fflush(stdout);

	/* normal end cases... */
	for (i = 0; i < sizeof(year) / sizeof(year[0]); ++i) {
	for (j = 0; j < sizeof(mmdd) / sizeof(mmdd[0]); ++j) {
		(void)snprintf(date, sizeof(date)
				, "%s%s", year[i], mmdd[j]
				);
		strcpy(org_date, date);
		if ((count = days_count(date, strlen(date))) < 1) {
			continue; /* skip `invalid arguments` case*/
		}
		printf("{org_date [%s](len=%lu)} "
			, org_date, (unsigned long)strlen(org_date)
			); (void)fflush(stdout);
		datep	= days_count_to_date_str(count
						, date
						, sizeof(date)
						);
		printf("days_count_to_date_str(day_count (%lld), "
			"date@%p, sz (%lu)) "
			"returns @%p [%s](len=%lu).\n"
			,				count
			, date, (unsigned long)sizeof(date)
			, datep, ((datep == NULL)? "(n/a)": datep)
			, (unsigned long)((datep == NULL)?
					(size_t)INT_MIN: strlen(datep)
					)
			); (void)fflush(stdout);
		if (((datep != NULL) && strcmp(datep, org_date) != 0)
		&& days_count(datep, strlen(datep)) != count) {
			printf("!!!FATAL!!! days_count_to_date_str()\n"
				); (void)fflush(stdout);
		}
	}}

	{	Duration_t		small, sd = { 1LL, 3LL, 3LL }
					, large = { 6LL, 10LL, 5LL }
					, closure, intersection
					;
		long long		d, limit;
		Duration_Inclusive_e	cmp_res;
		int			result;

		for (d = 0LL
		, limit = large.end_of + (large.begin_of - sd.begin_of)
		; d < limit
		; ++d) {
			(void)set_duration(memset(&small
						, (int)'\0'
						, sizeof(small)
						)
					, sd.begin_of + d
					, sd.end_of + d
					);
			cmp_res	= (Duration_Inclusive_e)INT_MIN;
			memset(&closure, (int)'\0', sizeof(closure));
			memset(&intersection
				, (int)'\0'
				, sizeof(intersection)
				);
			result	= compare_durations(&small
						, &large
						, &cmp_res
						, &closure
						, &intersection
						);
			if (result != 0) {
				printf("!!ERROR!! ");
			}
			printf("compare_durations("
				"dur1@%p={ %lld, %lld, %lld }, "
				"dur2@%p={ %lld, %lld, %lld}, "
				"cmp_result@%p, closure@%p, "
				"intersection@%p) returns %d"
				, (void *)&small
				,	small.begin_of, small.end_of
				,			small.days
				, (void *)&large
				,	large.begin_of, large.end_of
				,			large.days
				, (void *)&cmp_res, (void *)&closure
				, (void *)&intersection, result
				);
			if (result == 0) {
				printf(" (outputs cmp_result=%d, "
					"closure={ %lld, %lld, %lld }, "
					"intersection={ %lld, %lld, "
					"%lld })"
				, cmp_res
				, closure.begin_of, closure.end_of
				,			closure.days
				, intersection.begin_of
				,		intersection.end_of
				,		intersection.days
				);
			}
			printf(".\n"); (void)fflush(stdout);
		}
	}

	exit(EXIT_SUCCESS); /* program normally exits. */
}
